/* -------------------------------
     Surprise simulator header file
     Version date = 04.03.07
------------------------------- */

/*----------------------------------------------------------------------
COPYRIGHT 2004, 2005 PETER DAVIS
This file is part of "HMS Surprise - Frigate and brig Simulator for
Windows". That program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version. The file is distributed
in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this file; if not, write to the Free Software Foundation,
Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
----------------------------------------------------------------------*/

#define   STAYSAILS    7
#define   SQUARESAILS 11
#define   NRSAILS     18
#define   IMAXSHAD    12

extern HANDLE    hFile ;

extern HBITMAP   hBitmap_0 ;
extern HBITMAP   hBitmap_1 ;
extern HBITMAP   hBitmap_3 ;

extern HBRUSH    hBlownBrush ;   
extern HBRUSH    hDeckBrush ;
extern HBRUSH    hForeAftBrush ;
extern HBRUSH    hForeSailBrush ;   
extern HBRUSH    hLandBrush ;
extern HBRUSH    hMainSailBrush ;   
extern HBRUSH    hSeaBrush ;
extern HBRUSH    hSkyBrush ;
extern HBRUSH    hStaySailBrush ;   

extern HFONT     MyFont ;

extern HICON     hIcon ;

extern HINSTANCE hInstance ;

extern HMENU     hMenu ;

extern HPEN      hCoastPen ;
extern HPEN      hDarkGrayPen ;
extern HPEN      hGrayPen ;
extern HPEN      hGreenPen ;
extern HPEN      hHullPen ;
extern HPEN      hPinkPen ;
extern HPEN      hSeaBluePen ;
extern HPEN      hSkyBluePen ;
extern HPEN      hThickGrayPen ;
extern HPEN      hThickGreenPen ;
extern HPEN      hThickPinkPen ;
extern HPEN      hMastPen ;
extern HPEN      hRedPen ;
extern HPEN      hYellowPen ;

extern HWND      hwnd ;
extern HWND      hwndButton[9] ;
extern HWND      hwndChild[4] ;
extern HWND      hwndCheck[3] ;
extern HWND      hwndPropCancelButton ;
extern HWND      hwndPropOKButton ;
extern HWND      hwndPropText[60] ;
extern HWND      hwndProps ; 
extern HWND      hwndSlider[8] ;
extern HWND      hwndStatus ;
extern HWND      hwndText ;

extern LARGE_INTEGER liCounter ;
extern LARGE_INTEGER liFrequency ;
extern OPENFILENAME oFileName ;

extern POINT     pHull[7] ;
extern POINT     pStern[4] ;

extern WNDPROC   fnOldEditProc ;

extern BOOL   bAlertHeel ;
extern BOOL   bAlertLeeway ;
extern BOOL   bAlertRotat ;
extern BOOL   bAlertSpeed ;
extern BOOL   bAutoBearing ;
extern BOOL   bAutoBearing_2 ;
extern BOOL   bBrig ;
extern BOOL   bCompassRing ;
extern BOOL   bCoupleFore ;
extern BOOL   bCoupleMizzen ;
extern BOOL   bEasedJibs ;
extern BOOL   bEasedStaySails ;
extern BOOL   bEstablished ;
extern BOOL   bHelmsman ;
extern BOOL   bMapMustBePainted ;
extern BOOL   bMaxTrack ;
extern BOOL   bModernHelm ;
extern BOOL   bParalax ;
extern BOOL   bPaused ;
extern BOOL   bPlanViewIsChanged ;
extern BOOL   bPlayBack ;
extern BOOL   bRecording ;
extern BOOL   bSailPlanIsChanged ;
extern BOOL   bSavePosition ;
extern BOOL   bScroll ;
extern BOOL   bShowSlipStream ;
extern BOOL   bSternViewIsChanged ;
extern BOOL   bTracking ;
extern BOOL   bWindDirChange ;
extern BOOL   bWindSpeedChange ;
extern BOOL   bYardsmen ;

extern int    iAcceleration[6];
extern int    xActual ;
extern float  fAppWindAngle ;
extern float  fAppWindDirection ;
extern float  fAppWindSpeed ;
extern int    xAuto ;
extern int    cxAuto ;
extern int    iBearing ;
extern int    xBearing ;
extern int    yBearing ;
extern float  fBearingTime ;
extern int    iBestAngle ;
extern float  fBottomEdge ;
extern int    yBottomLine ;
extern float  fBowFactor;
extern int    cxChildPixels ;
extern int    xClient ;
extern int    yClient ;
extern int    iClicks ;
extern int    xClicks[10] ;
extern int    yClicks[10] ;
extern int    iCloseHauledAngle ;
extern float  fCOEForeAft ;
extern float  fCOEHeight ;
extern float  fCOELeeward ;
extern int    xColon ;
extern float  fCORDistance ;
extern float  fCSABow ;
extern float  fCSASide ;
extern float  fCSAStern ;
extern int    iCycles ;
extern float  fDegToRad ;
extern float  fDegreesPerMin ;
extern float  fDeltaHeel ;
extern float  fDeltaWindDir ;
extern float  fDeltaWindSpeed ;
extern int    iDisplayParam ;
extern float  fEndOfCycle ;
extern float  fEffectOfHeel ;
extern int    iEvent [15] ;
extern int    iEventCode [15] ;
extern int    iEventCode2 [15] ;
extern float  fEventTime [15] ;
extern int    iFields[5] ;
extern char   sFileName [] ;
extern char   sFileName2 [] ;
extern int    yFirst ;
extern int    iFirstForeStaySail ;
extern int    iFirstMainStaySail ;
extern int    iFocus ;
extern float  fFocleLength ;
extern float  fForwardDrag ;
extern float  fForwardThrust ;
extern int    cxFullScreen;
extern int    cyFullScreen;
extern float  fGunDeckHeight ;
extern float  fHeading ;
extern float  fHeadingDeviation ;
extern float  fHeelAngleFactor ;
extern float  fHeelDragFactor ;
extern float  fHeelInertFactor ;
extern float  fHeelingAngle ;
extern float  fHeelingThrust ;
extern int    iHeelParamHeight ;
extern int    iHeelParamWidth ;
extern float  fHeelResistFactor ;
extern float  fHeelSpeed ;
extern int    iHelmAngle ;
extern char   sHelmInstruction[] ;
extern float  fHighest ;
extern float  fHullCentroid ;
extern float  fHullEnd ;
extern float  fHullFactor ;
extern float  fHullSide ;
extern int    xHullTemplate[7] ;
extern int    yHullTemplate[7] ;
extern float  fIncrement ;
extern float  fIsleLat[13] ; 
extern float  fIsleLong[13] ; 
extern float  fIsleRadius[13] ; 
extern int    xJib ;
extern int    iJibSet ;
extern int    xJibValue ;
extern int    yJibValue ;
extern float  fLastDeviation ;
extern int    iLastMapCounter ;
extern float  fLastLat ;
extern float  fLastLong ;
extern float  fLastRealTime ;
extern float  fLastRecordTime ;
extern int    iLastRecTime ;
extern int    iLastReplayItem ;
extern float  fLastRotationalThrust ;
extern float  fLastSimTime ;
extern float  fLastTime ;
extern int    iLastValueToShow  ;
extern float  fLat[2000] ;
extern float  fLatitude ;
extern float  fLeewardDrag ;
extern float  fLeewardThrust ;
extern float  fLeewayAngle ;
extern float  fLeewaySpeed ;
extern int    xLeft ;
extern float  fLeftEdge ;
extern float  fLon[2000] ;
extern float  fLongitude ;
extern float  fLowestSailFoot[4] ;
extern int    iMadeSail;
extern float  fMagnify ;
extern int    cxMap ;
extern int    iMapCounter ;
extern int    iMapSkip ;
extern int    iMapSkipFactor ;
extern float  fMapRadius ;
extern float  fMapWidth ;
extern float  fMassFactor ;
extern float  fMastDistance[4] ;
extern float  fMastHeight[3] ;
extern int    xMax ;
extern int    yMax ;
extern float  fMaxAft ;
extern float  fMaxFore ;
extern float  fMaxHeelMoment ;
extern int    iMaxHelmAngle ;
extern int    iMaxJibAngle ;
extern int    iMaxShad ;
extern int    iMaxYardAngle[4];
extern char   sMessage[120] ;
extern int    cxMessage ;
extern int    xMessage ; 
extern int    yMessage ; 
extern int    iMessageNr ;
extern float  fMessageTime[6] ; 
extern int    iModifyMenu ;
extern char   sMyProgName[20] ;
extern float  fMyTime ;
extern int    iNewHelmAngle ;
extern float  fNewLat ;
extern float  fNewLong ;
extern float  fNewWindDirection ;
extern float  fNewWindSpeed ;
extern int    iNewYardAngle[4] ;
extern float  fNow ;
extern int    iNrSails ;
extern float  fOffsetAngle ;
extern int    iOfsetBottom ;
extern int    iOfsetLeft ;
extern int    iOfsetRight ;
extern int    iOfsetTop ;
extern float  fOldAppWindAngle ;
extern char   sOldDegreesPerMin[10] ;
extern char   sOldHeading[10] ;
extern char   sOldHeelingAngle[10] ;
extern float  fOldItemValue[60] ;
extern int    iOldJibAngle ;
extern char   sOldLeewayAngle[10] ;
extern float  fOldRotatInertFactor ;
extern int    iOldStaySailAngle ;
extern int    iOldSpankerStatus ;
extern int    iOldSpankerAngle ;
extern char   sOldSpeed[10] ;
extern char   sOldTrack[10] ;
extern float  fOldValue[60] ;
extern char   sOldWindDirection[10] ;
extern char   sOldWindDirText[30] ;
extern char   sOldWindSpeed[10] ;
extern char   sOldWindSpeedText[30] ;
extern float  fOneTenth ; 
extern int    xOrgPixels ;
extern char  *sParam[] ;
extern int    xParameter ;
extern int    yParameter ;
extern int    iParameterHeight ;
extern int    iParameterWidth ;
extern float  fPauseTime ;
extern float  fPi ;
extern int    xPos[12] ;
extern int    yPos[12] ;
extern float  fQDeckHeight ;
extern float  fQDeckLength ;
extern float  fRealTime ;
extern float  fRecordStartTime ;
extern float  fRelWindAngle ;
extern float  fRequiredHeading ;
extern float  fResistance ;
extern float  fRightEdge ;
extern float  fRightingMoment ;
extern float  fRotatDragFactor ;
extern float  fRotatInertFactor ;
extern float  fRotatForce[24] ;
extern float  fRotatInertFactor ;
extern float  fRotationalDrag ;
extern float  fRotatDragFactor ;
extern float  fRotationalInertia ;
extern float  fRotationalSpeed ;
extern float  fRotationalThrust ;
extern float  fRudderArea ;
extern float  fRudderFactor ;
extern float  fSailAngle[NRSAILS] ; 
extern int    iSailCanShad[4][NRSAILS][IMAXSHAD] ;
extern float  fSailClewDistance[STAYSAILS] ;
extern float  fSailClewElevation[STAYSAILS] ;
extern float  fSailCorner[NRSAILS] ;
extern float  fSailDepth[SQUARESAILS] ;
extern float  fSailEffectiveHead[NRSAILS] ;
extern float  fSailExposedFract[NRSAILS];
extern float  fSailFoot[NRSAILS] ;
extern float  fSailFootWidth[SQUARESAILS] ;
extern float  fSailGradientLeft[NRSAILS] ;
extern float  fSailGradientRight[NRSAILS] ;
extern float  fSailGradient2[NRSAILS] ;
extern float  fSailHead[SQUARESAILS] ;
extern float  fSailHeadDistance[STAYSAILS] ;
extern float  fSailHeadElevation[STAYSAILS] ;
extern float  fSailHeadwayForce[NRSAILS+5] ;
extern float  fSailHeadWidth[SQUARESAILS] ;
extern float  fSailHeelForce[NRSAILS+5] ;
extern float  fSailInterceptLeft[NRSAILS] ;
extern float  fSailInterceptRight[NRSAILS] ;
extern float  fSailIntercept2[NRSAILS] ;
extern char   sSailLastValue[NRSAILS+5] ;
extern float  fSailLeewayForce[NRSAILS+5] ;
extern int    iSailMaxReefs[NRSAILS] ;
extern float  fSailMaxSpeed[NRSAILS] ;
extern float  fSailMeanHeight[NRSAILS] ;
extern char  *sSailName[] ;
extern int    iSailOldSSStatus[STAYSAILS] ;
extern int    xSailParameter[NRSAILS+5] ; 
extern int    ySailParameter[NRSAILS+5] ; 
extern float  fSailPerpArea[NRSAILS+2] ;
extern float  fSailPerpForce[NRSAILS+2] ;
extern float  fSailPerpFract[NRSAILS+2] ;
extern float  xSailPlanFootLeft[NRSAILS] ;
extern float  ySailPlanFootLeft[NRSAILS] ;
extern float  xSailPlanFootRight[NRSAILS] ;
extern float  ySailPlanFootRight[NRSAILS] ;
extern float  xSailPlanHeadLeft[NRSAILS] ; 
extern float  ySailPlanHeadLeft[NRSAILS] ;
extern float  xSailPlanHeadRight[NRSAILS] ;
extern float  ySailPlanHeadRight[NRSAILS] ;
extern int    iSailType[NRSAILS] ;
extern int    iBrigSailSequence[5][NRSAILS] ;
extern int    iFrigateSailSequence[5][13] ;
extern float  fSailSSCentroid[STAYSAILS] ; 
extern int    iSailStatus[NRSAILS+5] ; 
extern float  fSailTackDistance[STAYSAILS] ;
extern float  fSailTackElevation[STAYSAILS] ;
extern float  fSailTheorMaxSpeed[NRSAILS] ;
extern int    iSailWarning[NRSAILS] ;
extern float  xSailWindFootLeft[NRSAILS] ;
extern float  xSailWindFootRight[NRSAILS] ;
extern float  xSailWindHeadLeft[NRSAILS] ;
extern float  xSailWindHeadRight[NRSAILS] ;
extern float  fScale ;
extern float  fScaleSail ;
extern int    iScreen ;
extern int    cyScroll ;
extern int    xScrollMax ;
extern int    yScrollMax ;
extern int    xScrollPos ;
extern int    yScrollPos ;
extern int    xSelected ;
extern int    iSeq ; 
extern float  fSetFraction[7] ;
extern float  fShipDraught ;
extern float  fShipLength ;
extern float  fShipMass ;
extern char   sShipMessage[6][41];
extern float  fShipTons ;
extern float  fShipWidth ;
extern float  fSideFactor ;
extern float  fSimTime ;
extern int    xSliders ;
extern int    ySliders[7] ;
extern int    iSpanker ;
extern float  fSpankerPeak ;
extern int    iSpacer ;
extern float  fSpeed ;
extern int    iSpeedFactor ;
extern char  *sStatusName[] ;
extern int    yStaysValue ;
extern float  fSternFactor;
extern int    cxSternView ;
extern int    cySternView ;
extern int    iTackStatus ;
extern int    cyTextHeight ;
extern int    iTick ;
extern char   sTitleName [] ;
extern char   sTitleName2 [] ;
extern float  fTopEdge ;
extern int    xTotals ;
extern int    yTotals ;
extern int    iTotalsHeight ;
extern int    iTotalsWidth ;
extern float  fTrack ;
extern int    xValues ;
extern float  fVerticalInertia ;
extern float  fWaterDragFactor ;
extern int    xWind ;
extern int    yWind ;
extern float  fWindDirection ;
extern int    iWindDirIncr ;
extern float  fWindSpeed ;
extern int    iWindSpeedIncr ;
extern int    xWindSpeed ;
extern int    iYardAngle[] ;
extern char  *sYardLevel[] ;
extern char  *sYardName[]  ;
extern int    iYardLevelShown ; 
