/* -------------------------------
     HMS Surprise header file
     Version date = 00.07.16
------------------------------- */

int    xActual ;
BOOL   bAlertHeel ;
BOOL   bAlertLeeway ;
BOOL   bAlertRotat ;
BOOL   bAlertSpeed ;
float  fAppWindAngle ;
float  fAppWindDirection ;
float  fAppWindSpeed ;
int    xAuto ; // coordinate of autopilot frame
int    iBearing ; // bearing of mouse pointer on planview
int    xBearing ; // coordinate of planview bearing
int    yBearing ; // coordinate of planview bearing
float  fBearingTime ; // time bearing on planview last redrawn
int    iBestAngle ; // for automatic helmsman
HBITMAP hBitmap ;
HBRUSH hBlownBrush ;   
float  fBottomEdge ;
int    yBottomLine ; // coordinate of last screen line 
float  fBowFactor; // modifies Frontal CSA (frontal aspect is not flat rectangle)
int    iCanShad[4][13][8] ; // stores sails which can shadow other sails
int    xChildPixels = 250 ;
int    yChildPixels = 250 ;
float  fCOEForeAft ;
float  fCOEHeight ;
float  fCOELeeward ;
int    xColon ;
float  fCSABow ; // Cross Sectional Area
float  fCSASide ;
float  fCSAStern ;
int    iCycles ; // counter for update cycles per half second
HBRUSH hDeckBrush ;
float  fDegreesPerMin ;
float  fDeltaHeel = 0 ;
float  fDeltaWindDir ;
float  fDeltaWindSpeed ;
int    iDisplayParam = 2 ;
int    iDoShad [13][8] ;
float  fEndOfCycle ;
BOOL   bEstablished ;
float  fEffectOfHeel ;
float  fEffPlanHeadLeft[13] ; // distance of top left of reefed sail from...
float  fEffPlanHeadRight[13] ; // distance of top right of reefed sail from...
float  fEffSailHead[13] ; // height of effective sail top above centre of rotation
float  fExposedFract[13]; // fraction of sail area delivering thrust
int    iFields[5] = { 26, 11, 60, 9, 39 } ; // number of fields in dialog window
OPENFILENAME oFileName ;
char   sFileName [_MAX_PATH] ;
int    yFirst ;
int    iFocus ; // dialog field with the focus  
float  fFocleLength ;
float  fFootWidth[13] ;
       // Width of foot of square sail (replaced from Surprise.cfg if present)
float  fForwardDrag ;
float  fForwardThrust ;
float  fGunDeckHeight ; // height in feet above sealevel
float  fHeading ; // in degrees
float  fHeadwayForce[17] ; // wind force acting to generate headway;
float  fHeadWidth[13] ;
       // Width of head of square sail (replaced from Surprise.cfg if present)
float  fHeelAngleFactor ; // scale factor to generate appropriate heel
float  fHeelDragFactor ; // arbitrary scale factor for drag against heeling
float  fHeelForce[18] ; // wind force acting to generate heeling;
float  fHeelInertFactor ; // arbitrary scale factor for inertia about longtitudinal axis (heel)
float  fHeelingAngle ;
float  fHeelingThrust ;
float  fHeelResistFactor ;
float  fHeelSpeed ;
int    iHelmAngle ; // Helm: + = starboard helm = port rudder
char   sHelmInstruction[] = "(await orders)" ;
BOOL   bHelmsman ;
POINT  pHull[7] ; //Bezier spline defines hull in Planview
int    xHullTemplate[7] = { -480, -1000, -1000, 0 , 1000, 1000, 480 } ;
int    yHullTemplate[7] = { -1000, -360, 360, 1000 , 360, -360, -1000 } ;
       // unscaled coordinates for pHull[]
HWND   hwnd ;
HWND   hwndButton[9] ;
HWND   hwndChild[4] ;
HWND   hwndCheck[3] ;
HWND   hwndHelm ;
HWND   hwndJib ;
HWND   hwndPropCancelButton ;
HWND   hwndPropOKButton ;
HWND   hwndPropText[60] ;
HWND   hwndProps ; 
HWND   hwndStatus ;
HWND   hwndYard[4] ;
float  fIncrement ;
HINSTANCE hInstance ;
float  fIsleLat[13] ; 
float  fIsleLong[13] ; 
float  fIsleRadius[13] ; 
int    xJib ; // coordinate of jib-box 
float  fJibDepth[3] ;
       // Depth of the jib (large, working, storm ; replaced from Surprise.cfg if present)
float  fJibFootWidth[3] ;
       // Width of the foot of the jib (replaced from Surprise.cfg if present)
char  *sJibName[3] = {   "Large jib", "Working jib", "Storm jib" } ;
int    iJibSet = 0 ;
float  fJibTheorMaxSpeed[3] ;
       // Theoretic speed at which the jib blows out (replaced from Surprise.cfg if present)
float  fJibWidth ; // horizontal distance from peak to tack of set jib;
HBRUSH hLandBrush ;
float  fLastDeviation ;
float  fLastLat ;
float  fLastLong ;
float  fLastTime = -1 ;
char   sLastValue[18] ; // last displayed value of current ssail parameter
int    iLastValueToShow = 12 ;
float  fLat[2000] ;
float  fLatitude = 0.0 ;
float  fLeewardDrag ;
float  fLeewardThrust ;
float  fLeewayAngle ;
float  fLeewayForce[17] ; // wind force acting to generate leeway
float  fLeewaySpeed = 0.0 ; // in knots
int    xLeft ;
float  fLeftEdge ;
float  fLon[2000] ; // remember course;
float  fLongtitude = 0.0 ;
float  fLowestSailFoot[4] ;
       // Height of foot of Fore course, main course, mizzen sail, jib above water-line
int    iMadeSail = 7; // all sails but royals set
int    iMapCounter ; // number of track positions used
BOOL   bMapMustBePainted ;
int    iMapPixels = 220 ;
float  fMapRadius ;
float  fMapWidth = 0.2 ; // width of map in nautical miles
float  fMassFactor = 1.0 ; // arbitrary conversion factor to convert tons to mass
float  fMastDistance[4] ;
       // Distance of Fore Mast, Main Mast, Mizzen Mast, Jib tack from centre of rotation
float  fMastHeight[3] ; // calculated mast height (hull + sail depths + nominal gaps)
int    xMax ; // width maximized client window
int    yMax ; // height maximized client window
float  fMaxHeelMoment ;
int    iMaxHelmAngle ; // Helm
int    iMaxJibAngle ; // Jib
int    iMaxReefs[13] ;
       // Maximum number of reefs (replaced from Surprise.cfg if present)
float  fMaxSpeed[13] ;
BOOL   bMaxTrack ;
int    iMaxYardAngle[4];
       // Maximum yard brace angle forFore Yard, Main Yard, Crossjack, Mizzen Boomfloat  fMeanSailHeight[13] ; // height om centre of (set part of) sail above centre of rotation
float  fMeanSailHeight[13] ; // height om centre of (set part of) sail above centre of rotation
char   sMessage[120] ; // text of message to show
int    xMessage ; 
int    yMessage ; 
int    iMessageNr = -1 ;
float  fMessageTime[6] = { 999999 , 999999 , 999999 , 999999 , 999999 , 999999 } ; 
int    iModifyMenu ; // index of modification menu now open (0=ship parameters...5=islands)
HFONT   MyFont ;
int    iNewHelmAngle = 0 ;
float  fNewLat ; // new position for island
float  fNewLong ;
float  fNewWindDirection ;
float  fNewWindSpeed ;
int    iNewYardAngle[4] ;
float  fNow ; // seconds since startup
float  fOldAppWindAngle = 0.0 ;
char   sOldDegreesPerMin[10] ;
WNDPROC fnOldEditProc ;
char   sOldHeading[10] ;
char   sOldHeelingAngle[10] ;
float  fOldItemValue[60] ;
int    iOldJibAngle ;
int    iOldJibStatus ;
char   sOldLeewayAngle[10] ;
int    iOldSpankerStatus ;
char   sOldSpeed[10] ;
float  fOldValue[60]; // to save old values during configuration change dialog 
char   sOldWindDirection[10] ;
char   sOldWindDirText[30] ;
char   sOldWindSpeed[10] ;
char   sOldWindSpeedText[30] ;
float  fOneThird ; // one third of current map width
int    xOrgPixels ; // x-origin pixel in sail plan 
BOOL   bParalax ; // true = sailplan shows view from wind direction
char  *sParam[9] =
       {   "Yard Angle", "Exposed percentage" , "Effective area" ,
           "Useful percentage of force" , "Useful force" ,
           "Forward thrust" , "Leeward thrust", "Rotational thrust" ,
           "Heeling thrust" } ;
int    xParameter ;
int    yParameter ;
BOOL   bPaused ;
float  fPerpForce[17] ; // wind force acting perpendicular to sail
float  fPerpFract[14] ; // fraction of wind perpendicular to sail
float  fPerpSailArea[14] ; // effective area of sail (area perp to wind)
float  fPlanFootLeft[13] ; // distance of bottom left from centre of rotation
float  fPlanFootRight[13] ; // distance of bottom right from centre of rotation
float  fPlanHeadLeft[13] ; // distance of top left from centre of rotation
float  fPlanHeadRight[13] ; // distance of top right from centre of rotation
BOOL   bPlanViewIsChanged ;
int    xPos[12] ; // coordinates of masts and yardarms
int    yPos[12] ; // coordinates of masts and yardarms
float  fQDeckHeight ; // height in feet above sealevel
float  fQDeckLength ;
float  fRelWindAngle ;
float  fRequiredHeading ;
float  fResistance ;
float  fRightEdge ;
float  fRightingMoment ;
float  fRotatDragFactor ; // arbitrary scale factor for rotational drag (turning)
float  fRotatInertFactor ; // arbitrary scale factor for interia about vertical axis (turning)
float  fRotatForce[18] ; // wind force acting to generate rotation
float  fRotatInertFactor ; // arbitrary scale factor for interia about vertical axis (turning)
float  fRotationalDrag ;
float  fRotatDragFactor ;
float  fRotationalInertia ;
float  fRotationalSpeed ;
float  fRotationalThrust ;
float  fRudderArea ; // square feet
float  fRudderFactor ; // arbitrary scale factor for effectiveness of rudder vs sail (density of water = 770 * dens. air)
float  fSailAngle[13] ; 
int    iSailClicks = -1 ;
float  fSailDepth[13] ; // Depth of square sail
float  fSailFoot[13] ; // height of bottom of sail above centre of rotation
float  fSailHead[13] ; // height of top of sail above centre of rotation
char   *sSailName[13] = 
       {   "Fore Royal", "Fore Topgallant", "Fore Topsail", "Foresail",
           "Main Royal" , "Main Topgallant" , "Main Topsail" , "Mainsail",
           "Mizzen Royal" , "Mizzen Topgallant" , "Mizzen Topsail" , "Mizzen sail" ,
           "???????????" } ;
int    xSailParameter[18] ;
int    ySailParameter[18] ;
BOOL   bSailPlanIsChanged ;
float  fSailScale ;
int    iSailStatus[13] ; // status bij opstarten (0 = set, 4 = furled)
int    iSailWarning[18] ; // warning code for sails ashiver
int    xSailClick[10] ; // coordinate of click on sail plan
int    ySailClick[10] ; // coordinate of click on sail plan
float  fScale ; //scale factor for Planview
int    xScrollPos ; // horizontal scroll in pixels
int    yScrollPos ; // vertical scroll in pixels
HBRUSH hSeaBrush ;
int    xSelected ;
int    iSeq ; 
          // parameter voor iSequence[]
          // [0] = mainsail drawing and jib not shadowed by foresails  
          // [1] = mainsail drawing and jib shadowed by foresails  
          // [2] = mainsail aback and jib not shadowed by foresails  
          // [3] = mainsail aback and jib shadowed by foresails  
int    iSequence[4][13]  =
       {  0 , 1 ,  2 ,  3 , 12 , 4 , 5 , 6 ,  7 , 8 , 9 , 10 , 11 ,
         12 , 0 ,  1 ,  2 ,  3 , 4 , 5 , 6 ,  7 , 8 , 9 , 10 , 11 ,
          8 , 9 , 10 , 11 ,  4 , 5 , 6 , 7 ,  0 , 1 , 2 ,  3 , 12 ,
          8 , 9 , 10 , 11 ,  4 , 5 , 6 , 7 , 12 , 0 , 1 ,  2 ,  3 } ; 
       // z-order of sails (to calculate shadowing)
float  fSetFraction[6] ; // Fraction of sail set by a particular SailStatus
int    iShadEnd[13][8] ; // top of shaded band above sail foot
int    iShadOfset[13][8] ; // delta h between shadowed & shadowing sail
int    iShadStart[13][8] ; // bottom of shaded band above sail foot
float  fShipDraught ; // feet
float  fShipLength ; // feet
float  fShipMass ;
char   sShipMessage[6][41];
float  fShipTons ; // tons
float  fShipWidth ; // feet
BOOL   bShowSlipStream = FALSE ;
float  fSideFactor ;
HBRUSH hSkyBrush ;
int    xSliders ;
int    ySliders[5] ;
float  fSpeed ;
char  *sStatusName[6] =
           { "Set" , "1 reef" , "2 reefs" , "3 reefs" , "Furled" , "Blown out" } ;
POINT  pStern[4] ; //Bezier spline defines hull in Sternview
float  fSternFactor; // modifies Frontal CSA (stern aspect is not flat rectangle)
BOOL   bSternViewIsChanged ;
int    iTackStatus ;
int    iTextHeight ;
float  fTheorMaxSpeed[13] ; // Theoretical maximum wind speed for sail
char   sTitleName [_MAX_FNAME + _MAX_EXT ] ;
float  fTopEdge ;
int    xTotals ;
int    yTotals ;
BOOL   bTracking = TRUE ;
int    xValues ;
float  fVerticalInertia ;
float  fWaterDragFactor ; // arbitrary scale factor for drag of water (viscosity of water = 66 * viscosity of air)
int    xWind ;
int    yWind ;
BOOL   bWindDirChange ;
float  fWindDirection ; // in  (usual notation)
int    iWindDirIncr = 128 ;
float  fWindFootLeft[13] ; // distance ... when seen from direction of wind
float  fWindFootRight[13] ; // distance ... when seen from direction of wind
float  fWindHeadLeft[13] ; // distance ... when seen from direction of wind
float  fWindHeadRight[13] ; // distance ... when seen from direction of wind
float  fWindSpeed ; // in knots;
BOOL   bWindSpeedChange ;
int    iWindSpeedIncr = 128 ;
int    xWindSpeed ;
int    iYardAngle[4] ; // brace angle of lowest yard on mast
char  *sYardLevel[4] =
       { "Royal yards" , "Topgallant yards" , "Topsail yards" , "Lower yards" } ;
char  *sYardName[4] = { "Fore" , "Main" , "Mizzen", "Mizzen boom" } ;
int    iYardLevelShown = 3 ; // yards to display in PlanView (3=courses; 2=topsail; 1=topg'l'nt; 0=royal)
BOOL   bYardsmen ;

