/*-----------------------------------------
   AutoNav.C -- Helmsman and Yardsmen
   Version date: 02.12.08
  -----------------------------------------*/

#define PI                 3.141592748
#define DEGTORAD           PI/180.0

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "External.h" 

// Prototypes:
void   ManBraces () ;
void   ManHelm () ;
void   Yardsmen () ;

extern void  CanShadow () ;
extern void  CheckJibStatus () ;
extern void  SailPlan () ;
extern int   Sgn (float) ;
extern void  ShowMessage () ;
extern void  ShowActualHelmAngle() ;
extern void  ShowActualYardAngle () ;
extern void  ShowSelectedHelmAngle() ;
extern void  ShowSelectedYardAngle(int) ;
extern void  YardAdjust (int) ;

/* ------------------------------
     ManBraces: calculate new yard angles for automatic yardsmen
     Version date: 02.12.08
-------------------------------*/
  void ManBraces ()
  { 
  HDC      hdc ;
  float    fRqdFromWind, fHdgFromWind ;
  int      iI ;
  int      iNewValue ;
  int      yThis ;

  hdc = GetDC (hwnd) ;

  if (iTackStatus > 0)
    {
    switch (iTackStatus)
      {
      case 1 :
        if (iSailStatus[12] != 4)
          {
          fSailAngle[12]=0.0 ;
          iSailStatus[12] = 4 ;
          CheckJibStatus () ;
          SailPlan () ;
          CanShadow () ;
          strcpy(sMessage, "Furl jib") ; 
          ShowMessage() ;
          }
        iTackStatus = 2 ;
        break ;
      case 2 :
        if (fRelWindAngle > 0)
          iNewHelmAngle = -20 ;
        else
          iNewHelmAngle = 20 ;
        SetScrollPos (hwndHelm, SB_CTL, iNewHelmAngle, TRUE) ;
        ShowSelectedHelmAngle () ;
        ShowActualHelmAngle () ;
        strcpy(sMessage, "20 degree lee helm") ; 
        ShowMessage() ;
        iTackStatus = 3 ;
        break ;
      case 3 :
        if (fabs(fAppWindAngle) > 170.0)
          {
          if (iSailStatus[11] != 4)
            {
            iSailStatus[1] = 4 ;
            SailPlan () ;
            CanShadow () ;
            strcpy(sMessage, "Furl spanker") ; 
            ShowMessage() ;
            } 
          }
        if (fSpeed < 0.0 && iNewHelmAngle != 0)
          {
          iNewHelmAngle = 0 ;
          SetScrollPos (hwndHelm, SB_CTL, iNewHelmAngle, TRUE) ;
          ShowSelectedHelmAngle () ;
          strcpy(sMessage, "Helm amidships") ; 
          ShowMessage() ;
          }
        if (fabs(fAppWindAngle) > 169.0)
          {
          iNewYardAngle[1] = -Sgn(iYardAngle[1]) * iMaxYardAngle[1] ; 
          iNewYardAngle[2] = -Sgn(iYardAngle[2]) * iMaxYardAngle[2] ;
          SetScrollPos (hwndYard[1], SB_CTL, iNewYardAngle[1], TRUE) ;
          SetScrollPos (hwndYard[2], SB_CTL, iNewYardAngle[2], TRUE) ;
          ShowSelectedYardAngle(1) ;
          ShowSelectedYardAngle(2) ;
          strcpy(sMessage, "Reverse afteryards") ; 
          ShowMessage() ;
          iTackStatus = 4 ;
          }
        break ;
      case 4 :
        if (fabs(fAppWindAngle) > 170.0)
          {
          if (iSailStatus[11] != 4)
            {
            iSailStatus[11] = 4 ;
            SailPlan () ;
            CanShadow () ;
            strcpy(sMessage, "Furl spanker") ; 
            ShowMessage() ;
          }
        }
        if ((fSpeed < 0.0) && (iNewHelmAngle != 0))
          {
          iNewHelmAngle = 0 ;
          SetScrollPos (hwndHelm, SB_CTL, iNewHelmAngle, TRUE) ;
          ShowSelectedHelmAngle () ;
          strcpy(sMessage, "Helm amidships") ; 
          ShowMessage() ;
          } 
        if (fabs(fAppWindAngle) < 150.)
          {
          iNewYardAngle[0] = -Sgn(iYardAngle[0]) * iMaxYardAngle[0] ;
          SetScrollPos (hwndYard[0], SB_CTL, iNewYardAngle[2], TRUE) ;
          ShowSelectedYardAngle(0) ;
          strcpy(sMessage, "Reverse headyards") ; 
          ShowMessage() ;
          iTackStatus = 5 ;
          } 
        break ;
      case 5 :
        if ((fSpeed < 0.0) && (iNewHelmAngle != 0))
          {
          iNewHelmAngle = 0 ;
          SetScrollPos (hwndHelm, SB_CTL, iNewHelmAngle, TRUE) ;
          ShowSelectedHelmAngle () ;
          strcpy(sMessage, "Helm amidships") ; 
          ShowMessage() ;
          }
        if (iOldJibStatus != 4)
          {
          iSailStatus[12] = iOldJibStatus ; // 'jib reset
          CheckJibStatus() ;
          strcpy(sMessage, "Set flatted jib") ; 
          ShowMessage() ;
          SailPlan () ;
          CanShadow () ;
          }
        iTackStatus = 6 ;
        break ;
      case 6 :
        if ((fSpeed < 0.0) && (iNewHelmAngle != 0))
          {
          iNewHelmAngle = 0 ;
          SetScrollPos (hwndHelm, SB_CTL, iNewHelmAngle, TRUE) ;
          ShowSelectedHelmAngle () ;
          strcpy(sMessage, "Helm amidships") ; 
          ShowMessage() ;
          }
        if (fabs(fAppWindAngle) < 115.0)
          {
          if (iOldJibAngle != 0)
            {
            //SetScrollPos (hwndJib, SB_CTL, iOldJibAngle, TRUE) ;
            strcpy(sMessage, "Veer jib") ; 
            ShowMessage() ;
            fSailAngle[12] = Sgn(fAppWindAngle) * iOldJibAngle ; // jib veered
            CheckJibStatus() ;
            }
          if (iOldSpankerStatus != 4)
            {
            iSailStatus[11] = iOldSpankerStatus ;
            strcpy(sMessage, "Reset spanker") ; 
            ShowMessage() ;
            SailPlan () ;
            CanShadow () ;
            }
          fLastDeviation = fHeading - fRequiredHeading ;
          if (fLastDeviation > 180.0)
            fLastDeviation = fLastDeviation - 360.0 ;
          if (fLastDeviation < -180.0)
            fLastDeviation = fLastDeviation + 360.0 ;
          strcpy(sMessage, "Tack complete") ; 
          ShowMessage() ;
          iTackStatus = 0 ;
          break ;
        }
      }
    return ;  
    }

  iNewValue = -fAppWindAngle / 2. ;

  if (abs(fAppWindAngle) <= 2*iMaxYardAngle[1])
    {
    // not close-hauled
    for (iI = 0 ; iI<=2 ; iI++)
      { 
      if (iNewYardAngle[iI] != iNewValue)
        {
        iNewYardAngle[iI] = iNewValue ;
        SetScrollPos (hwndYard[iI], SB_CTL, iNewYardAngle[iI], TRUE) ;
        yThis = ySliders[iI]-5 ;
        SelectObject(hdc,GetStockObject(NULL_PEN)) ;
        Rectangle (hdc, xSelected, yThis , xSelected + 50, yThis + iTextHeight );
        SelectObject(hdc,GetStockObject(BLACK_PEN)) ;
        switch (Sgn(iNewYardAngle[iI]))
          {
          case -1 :
            TextOut (hdc, xSelected, yThis, sMessage, 
              sprintf(sMessage, "%3d  port", abs(iNewYardAngle[iI]))) ; 
            break ;
          case 1 :
            TextOut (hdc, xSelected, yThis, sMessage,
              sprintf(sMessage, "%3d  stbd", abs(iNewYardAngle[iI]))) ; 
            break ;
          default :
            TextOut (hdc, xSelected, yThis, "amidships",9) ; 
          }
        ShowActualYardAngle (iI) ;
        }
      }
    }
  else
    {
    // ship is close-hauled 
    if (bHelmsman)
      {
      fRqdFromWind = fRequiredHeading - fWindDirection ;
      if (fRqdFromWind < -180.0)
        fRqdFromWind = fRqdFromWind + 360.0 ;
      if (fRqdFromWind > 180.0)
        fRqdFromWind = fRqdFromWind - 360.0 ;
      fHdgFromWind = fHeading - fWindDirection ;
      if (fHdgFromWind < -180.0)
        fHdgFromWind = fHdgFromWind + 360.0 ;
      if (fHdgFromWind > 180.0)
        fHdgFromWind = fHdgFromWind - 360.0 ;
      // check if tack is required
      if (Sgn(fRqdFromWind) != Sgn(fHdgFromWind))
        {
        // tack is required
        strcpy(sMessage, "Ready about") ; 
        ShowMessage() ;
        iOldJibStatus = iSailStatus[12] ;
        iOldJibAngle = fSailAngle[12] ;
        iOldSpankerStatus = iSailStatus[11] ;
        iTackStatus = 1 ;
        return ;
        }
      else
        {
        // this is the best atainable heading
        if (fabs(fRqdFromWind) < fabs(fHdgFromWind))
          {
          if (fRqdFromWind > 0) 
            fRequiredHeading = ceil(fHeading) ;
          else
            fRequiredHeading = floor(fHeading) ;
          SelectObject (hdc, GetStockObject(NULL_PEN)) ;
          Rectangle (hdc, xAuto, yMessage+21, xAuto+80, yMessage+22+iTextHeight) ;
          SelectObject (hdc, GetStockObject(BLACK_PEN)) ;
          SetTextAlign (hdc,TA_CENTER|TA_TOP) ;
          TextOut (hdc, xAuto+40, yMessage+21, sHelmInstruction, sprintf(sHelmInstruction, "steer %3.0f ", fRequiredHeading)); 
          SetTextAlign (hdc,TA_LEFT|TA_TOP) ;
          sprintf(sMessage, "Close-hauled heading %3.0f ", fRequiredHeading);
          ShowMessage() ;
          }
        }
      }
    }

  ReleaseDC (hwnd, hdc) ;
  }

/* ------------------------------
     ManHelm: calculate new helm position for automatic helmsman
     Version date: 99.08.23
-------------------------------*/

void ManHelm () 
  {
  int    iDelta ;
  HDC    hdc ;
  float  fHeadingDeviation ;
  int    iI ;
  float  fRF, fRF2, fRFmin ;
  char   cTrend ;

  fHeadingDeviation = fHeading - fRequiredHeading ;
  if (fHeadingDeviation > 180.0)
    fHeadingDeviation = fHeadingDeviation - 360.0 ;
  if (fHeadingDeviation < -180.0)
    fHeadingDeviation = fHeadingDeviation + 360.0 ;

  if (bEstablished)
    {
    if (fHeadingDeviation < -0.5)
      iNewHelmAngle = iBestAngle - 1 ;
    else
      {
      if (fHeadingDeviation > 0.5)
        iNewHelmAngle = iBestAngle + 1 ;
      else
        iNewHelmAngle = iBestAngle ;
      }

    SetScrollPos (hwndHelm, SB_CTL, iNewHelmAngle, TRUE) ;
    ShowSelectedHelmAngle () ;
    ShowActualHelmAngle () ;
    if (fabs(fHeadingDeviation) > 3.0)
      {
      bEstablished = FALSE ;
      hdc = GetDC (hwnd) ;
      SelectObject (hdc, GetStockObject(NULL_PEN)) ;
      Rectangle (hdc, xAuto, yMessage+21, xAuto+80, yMessage+22+iTextHeight) ;
      SelectObject (hdc, GetStockObject(BLACK_PEN)) ;
      SetTextAlign (hdc,TA_CENTER|TA_TOP) ;
      TextOut (hdc, xAuto+40, yMessage+21, sHelmInstruction, sprintf(sHelmInstruction, "steer %3.0f ", fRequiredHeading)); 
      SetTextAlign (hdc,TA_LEFT|TA_TOP) ;
      strcpy(sMessage, "Helmsman: watch your helm") ;
      ShowMessage() ;
      ReleaseDC (hwnd, hdc) ;
      return ;
      }
    }
  else
    {
    if (fabs(fHeadingDeviation) < fabs(fLastDeviation))
      cTrend = '-' ;
    else
      cTrend = '+' ;
    fLastDeviation = fHeadingDeviation ;
    if (cTrend == '+')
      { 
      if (fabs(fHeadingDeviation) < 10.0)
        iDelta = 1 ;
      else
        iDelta = 5 ;
      if (abs(iNewHelmAngle) < (iMaxHelmAngle - 10))
        {
        iNewHelmAngle = iNewHelmAngle + iDelta * Sgn(fHeadingDeviation) ;
        SetScrollPos (hwndHelm, SB_CTL, iNewHelmAngle, TRUE) ;
        ShowSelectedHelmAngle() ;
        ShowActualHelmAngle() ;
        }
      }

    if (fabs(fHeadingDeviation) < 0.4)
      {
      // calculate appropriate rudder angle
      fRFmin = 1000000000.0 ;
      iBestAngle = -iMaxHelmAngle ;
      for (iI = (5 - iMaxHelmAngle) ; iI <= (iMaxHelmAngle - 5) ; iI++)
        {
        fRF2 = fabs(fRudderArea * sin(iI * DEGTORAD)) ; // effective area
        fRF = fabs(sin(iI * DEGTORAD)) ; // useful fraction
        fRF = fRF2 * fSpeed * fSpeed * fRF * fRudderFactor / 1000.0 ; // useful force
        fRF = Sgn(fSpeed) * Sgn((float) iI) * fRF * cos(iI * DEGTORAD) ; // useful force for leeway
        fRF = -fRF * fShipLength / 2.0 ;
        fRF = fRotationalThrust + -fRotatForce[13] + fRF ;
        if (fabs(fRF) < fabs(fRFmin))
          {
          fRFmin = fRF ;
          iBestAngle = iI ;
          }
        }
        iNewHelmAngle = iBestAngle ;
        hdc = GetDC (hwnd) ;
        SelectObject (hdc, GetStockObject(NULL_PEN)) ;
        Rectangle (hdc, xAuto, yMessage+21, xAuto+80, yMessage+22+iTextHeight) ;
        SelectObject (hdc, GetStockObject(BLACK_PEN)) ;
        SetTextAlign (hdc,TA_CENTER|TA_TOP) ;
        TextOut (hdc, xAuto+40, yMessage+21, sHelmInstruction, sprintf(sHelmInstruction, "steering %3.0f ", fRequiredHeading)); 
        SetTextAlign (hdc,TA_LEFT|TA_TOP) ;
        ReleaseDC (hwnd, hdc) ;
        SetScrollPos (hwndHelm, SB_CTL, iNewHelmAngle, TRUE) ;
        ShowSelectedHelmAngle() ;
        ShowActualHelmAngle() ;
        sprintf(sMessage, "Helmsman steering %3.0f ", fRequiredHeading) ;
        ShowMessage() ;
        bEstablished = TRUE ;
      }
    }
  }

/* ------------------------------
     Yardsmen: activate or deactivate automatic helmsman
     Version date: 99.08.16
-------------------------------*/

void Yardsmen () 
  {
  HDC      hdc ;

  hdc = GetDC (hwnd) ;
  SelectObject(hdc, GetStockObject(NULL_PEN)) ;
  Rectangle (hdc, xAuto+10, yMessage+58, xAuto+80, yMessage+58+iTextHeight) ;
  SelectObject(hdc, GetStockObject(BLACK_PEN)) ;
  if (!bYardsmen)
    {
    bYardsmen = TRUE ;
    SetTextAlign (hdc,TA_CENTER|TA_TOP) ;
    TextOut (hdc, xAuto+40, yMessage+58, " man braces ",12) ; 
    SetTextAlign (hdc,TA_LEFT|TA_TOP) ;
    strcpy(sMessage, "Yardsmen: man braces") ; 
    ShowMessage() ;
    SetTextColor(hdc, RGB(160,160,160)) ;  // gray
    TextOut (hdc, xSliders, ySliders[0]-5, "Fore", 4) ; 
    TextOut (hdc, xSliders, ySliders[1]-5, "Main", 4) ; 
    TextOut (hdc, xSliders, ySliders[2]-5, "Mizzen", 6) ; 
    SetTextColor(hdc, RGB(0,0,0)) ;  // black
    }
  else
    {
    bYardsmen = FALSE ;
    SetTextAlign (hdc,TA_CENTER|TA_TOP) ;
    TextOut (hdc, xAuto+40, yMessage+58, "(await orders)",14) ; 
    SetTextAlign (hdc,TA_LEFT|TA_TOP) ;
    strcpy(sMessage, "Yardsmen: await orders") ; 
    ShowMessage() ;
    TextOut (hdc, xSliders, ySliders[0]-5, "Fore", 4) ; 
    TextOut (hdc, xSliders, ySliders[1]-5, "Main", 4) ; 
    TextOut (hdc, xSliders, ySliders[2]-5, "Mizzen", 6) ; 
    }
 
  SetFocus (hwndCheck[2]) ;
  ReleaseDC (hwnd, hdc) ;
  }


