/*-----------------------------------------
   OTH2.C -- Other procedures module #2
   Version date: 00.06.10
  -----------------------------------------*/

#include <windows.h>
#include <commctrl.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "External.h" 

// Prototypes:
void   AdjustSails() ;
void   DecrSail () ;
void   IncrSail () ;
void   MakeSail () ;
void   Pause () ;
void   ShowMessage () ;
void   ShowStatusMessage () ;
void   ShowYardShown () ;

extern void   CanShadow () ;
extern void   CheckJibStatus () ;
extern void   JibSelect () ;
extern void   Pause () ;
extern void   PlanView () ;
extern void   SailPlan () ;
extern void   ShowActualJibAngle () ;

/*-----------------------------------------
   AdjustSails
   Version date: 99.09.25
  -----------------------------------------*/
void AdjustSails ()
  {
  int    iI, iJ ;
  int    iThisSail ;
  int    xClick ;
  int    yClick ;
  int    xOfset ;
  int    iNrReefs ;
  BOOL   bSail ;
  int    iThisStatus ;
  float  fXFeet, fYFeet ;

  xClick = xSailClick[0] ;
  yClick = ySailClick[0] ;
  if (xClick < xOrgPixels)
    xClick = - (xOrgPixels-xClick) ;
  else
    xClick = xClick - xOrgPixels ;
  yClick = (yChildPixels* 0.85) - yClick;
  fXFeet =  xClick * (1000./fSailScale)/xChildPixels;
  fYFeet =  yClick * (1000./fSailScale)/yChildPixels;

  for (iI = 1 ; iI <= iSailClicks ; iI++)
    {
    xSailClick[iI - 1] = xSailClick[iI] ;
    ySailClick[iI - 1] = ySailClick[iI] ;
    }
  iSailClicks-- ;

  bSail = FALSE ;
  for (iI = 12 ; iI >= 0 ; iI--)
    {
    iJ=iI ;
    iJ = iSequence[1][iI] ;
    switch (iJ)
      {
      case 0 :
      case 1 :
      case 2 :
      case 3 :
        xOfset = fMastDistance[0] ;
        break ;
      case 4 :
      case 5 :
      case 6 :
      case 7 :
        xOfset = fMastDistance[1] ;
        break ;
      case 8 :
      case 9 :
      case 10 :
      case 11 :
        xOfset = fMastDistance[2] ;
        break ;
      case 12 :
        xOfset = fMastDistance[3] ;
        break ;
      }
    
    if ((fXFeet > (xOfset + fPlanFootLeft[iJ])) && (fXFeet < (xOfset + fPlanFootRight[iJ])))
      {
      if ((fYFeet > fSailFoot[iJ]) && (fYFeet < fSailHead[iJ]))
        {
        iThisSail = iJ ;
        bSail = TRUE ;
        break ;
        }
      }
    }

    if (!bSail)
      {
      strcpy (sMessage,"No sail selected") ;
      ShowMessage() ;
      return ;
      }

  iNrReefs = iMaxReefs[iThisSail] ;
  iThisStatus = iSailStatus[iThisSail] ;

  // sail is blown uit
  if (iThisStatus == 5)
    {
    iSailStatus[iThisSail] = 4 ;
    fEffSailHead[iThisSail] = fSailFoot[iThisSail] ;
    sprintf(sMessage, "new %s bent", sSailName[iThisSail]) ; 
    ShowMessage () ; 
    SailPlan () ;
    CanShadow () ;
    return ;
    }

  if (iNrReefs == 0) 
    {
    // sail is not reefable
    if (iThisStatus == 4)
      {
      iSailStatus[iThisSail] = 0 ; // set
      fEffSailHead[iThisSail] = fSailHead[iThisSail ] ;
      sprintf(sMessage, "%s set", sSailName[iThisSail]) ; 
      ShowMessage () ; 
      }
    else
      {
      iSailStatus[iThisSail] = 4 ; // furled
      fEffSailHead[iThisSail] = fSailFoot[iThisSail] ;
      sprintf(sMessage, "%s furled", sSailName[iThisSail]) ; 
      ShowMessage () ; 
      if (iThisSail==12)
        {
        fSailAngle[12] = 0. ; // haul in jib upon furling
        ShowActualJibAngle () ;
        }
      }
    }
  else
    {
    // sail is reefable
    if (fYFeet < fEffSailHead[iThisSail])
      {
      if (iThisStatus == iNrReefs)
        {
        // all reefs are already taken in; // furl
        iSailStatus[iThisSail] = 4 ;
        fEffSailHead[iThisSail] = fSailFoot[iThisSail] ;
        sprintf(sMessage, "%s furled", sSailName[iThisSail]) ; 
        ShowMessage () ; 
        } 
      else
        {
        // take in reef
        if ((iThisStatus < iNrReefs) && (iThisStatus != 4))
          {
          sprintf(sMessage, "%s reefed", sSailName[iThisSail]) ; 
          ShowMessage () ; 
          iSailStatus[iThisSail] = iThisStatus + 1 ;
          fEffSailHead[iThisSail] = fSailFoot[iThisSail] + fSailDepth[iThisSail] 
            * fSetFraction[iSailStatus[iThisSail]] ;
          fMeanSailHeight[iThisSail] = (fEffSailHead[iThisSail] + fSailFoot[iThisSail]) / 2 ;
          } 
        else
          {
          sprintf(sMessage, "%s is furled", sSailName[iThisSail]) ; 
          ShowMessage () ; 
          }
        }
      }
    else
      {
      // let out reef
      if (iThisStatus > 0)
        {
        if (iThisStatus == 4)
          {
          // sail was furled
          iSailStatus[iThisSail] = iNrReefs ;
          sprintf(sMessage, "%s set close reefed", sSailName[iThisSail]) ; 
          ShowMessage () ; 
          fEffSailHead[iThisSail] = fSailFoot[iThisSail] + fSailDepth[iThisSail] 
            * fSetFraction[iSailStatus[iThisSail]] ;
          fMeanSailHeight[iThisSail] = (fEffSailHead[iThisSail] + fSailFoot[iThisSail]) / 2 ;
          }
        else
          {
          iSailStatus[iThisSail] = iThisStatus -1 ;
          fEffSailHead[iThisSail] = fSailFoot[iThisSail] + fSailDepth[iThisSail] 
            * fSetFraction[iSailStatus[iThisSail]] ;
          fMeanSailHeight[iThisSail] = (fEffSailHead[iThisSail] + fSailFoot[iThisSail]) / 2 ;
          sprintf(sMessage, "%s reef shaken out", sSailName[iThisSail]) ; 
          ShowMessage () ; 
          } 
        }  
      else
        { 
        sprintf(sMessage, "%s already set", sSailName[iThisSail]) ; 
        ShowMessage () ; 
        }
      }
    }
  SailPlan () ;
  CanShadow () ;
  if (iThisSail == 12)
    {
    CheckJibStatus() ;
    PlanView() ;
    }
  }

/*-----------------------------------------
   DecrSail: Programmed decrease of sail
   Version date: 99.07.03
  -----------------------------------------*/
void DecrSail()
  {
  EnableWindow (hwndButton[2], TRUE) ;
  if (iMadeSail > 0 )
    {
    iMadeSail = iMadeSail - 1 ;
    MakeSail() ;
    } 
  if (iMadeSail == 0)
    EnableWindow (hwndButton[3], FALSE) ;
  SetFocus (hwndCheck[2]) ;
  }

/*-----------------------------------------
   IncrSail: Programmed increase of sail
   Version date: 99.07.02
  -----------------------------------------*/
void IncrSail()
  {
  EnableWindow (hwndButton[3], TRUE) ;
  if (iMadeSail < 8 )
    {
    iMadeSail = iMadeSail + 1 ;
    MakeSail() ;
    } 
  if (iMadeSail == 8)
    EnableWindow (hwndButton[2], FALSE) ;
  SetFocus (hwndCheck[2]) ;
  }

/*-----------------------------------------
   MakeSail: Programmed sail status
   Version date: 99.06.26
  -----------------------------------------*/
void MakeSail()
  {
  int    iI ;

  switch (iMadeSail)
    {
    case 8 :
      iSailStatus[0] = 0 ;
      iSailStatus[1] = 0 ;
      iSailStatus[2] = 0 ;
      iSailStatus[3] = 0 ;
      iSailStatus[4] = 0 ;
      iSailStatus[5] = 0 ;
      iSailStatus[6] = 0 ;
      iSailStatus[7] = 0 ;
      iSailStatus[8] = 0 ;
      iSailStatus[9] = 0 ;
      iSailStatus[10] = 0 ;
      iSailStatus[11] = 0 ;
      iSailStatus[12] = 0 ;
      iJibSet = 0 ;
      break ;
    case 7 :
      iSailStatus[0] = 4 ;
      iSailStatus[1] = 0 ;
      iSailStatus[2] = 0 ;
      iSailStatus[3] = 0 ;
      iSailStatus[4] = 4 ;
      iSailStatus[5] = 0 ;
      iSailStatus[6] = 0 ;
      iSailStatus[7] = 0 ;
      iSailStatus[8] = 4 ;
      iSailStatus[9] = 0 ;
      iSailStatus[10] = 0 ;
      iSailStatus[11] = 0 ;
      iSailStatus[12] = 0 ;
      iJibSet = 0 ;
      break ;
    case 6 :
      iSailStatus[0] = 4 ;
      iSailStatus[1] = 4 ;
      iSailStatus[2] = 0 ;
      iSailStatus[3] = 0 ;
      iSailStatus[4] = 4 ;
      iSailStatus[5] = 4 ;
      iSailStatus[6] = 0 ;
      iSailStatus[7] = 0 ;
      iSailStatus[8] = 4 ;
      iSailStatus[9] = 4 ;
      iSailStatus[10] = 0 ;
      iSailStatus[11] = 0 ;
      iSailStatus[12] = 0 ;
      iJibSet = 1 ;
      break ;
    case 5 :
      iSailStatus[0] = 4 ;
      iSailStatus[1] = 4 ;
      iSailStatus[2] = 1 ;
      iSailStatus[3] = 0 ;
      iSailStatus[4] = 4 ;
      iSailStatus[5] = 4 ;
      iSailStatus[6] = 1 ;
      iSailStatus[7] = 0 ;
      iSailStatus[8] = 4 ;
      iSailStatus[9] = 4 ;
      iSailStatus[10] = 1 ;
      iSailStatus[11] = 0 ;
      iSailStatus[12] = 0 ;
      iJibSet = 1 ;
      break ;
    case 4 :
      iSailStatus[0] = 4 ;
      iSailStatus[1] = 4 ;
      iSailStatus[2] = 2 ;
      iSailStatus[3] = 0 ;
      iSailStatus[4] = 4 ;
      iSailStatus[5] = 4 ;
      iSailStatus[6] = 2 ;
      iSailStatus[7] = 0 ;
      iSailStatus[8] = 4 ;
      iSailStatus[9] = 4 ;
      iSailStatus[10] = 3 ;
      iSailStatus[11] = 0 ;
      iSailStatus[12] = 0 ;
      iJibSet = 1 ;
      break ;
    case 3 :
      iSailStatus[0] = 4 ;
      iSailStatus[1] = 4 ;
      iSailStatus[2] = 2 ;
      iSailStatus[3] = 1 ;
      iSailStatus[4] = 4 ;
      iSailStatus[5] = 4 ;
      iSailStatus[6] = 2 ;
      iSailStatus[7] = 1 ;
      iSailStatus[8] = 4 ;
      iSailStatus[9] = 4 ;
      iSailStatus[10] = 3 ;
      iSailStatus[11] = 1 ;
      iSailStatus[12] = 0 ;
      iJibSet = 1 ;
      break ;
    case 2 :
      iSailStatus[0] = 4 ;
      iSailStatus[1] = 4 ;
      iSailStatus[2] = 3 ;
      iSailStatus[3] = 1 ;
      iSailStatus[4] = 4 ;
      iSailStatus[5] = 4 ;
      iSailStatus[6] = 3 ;
      iSailStatus[7] = 1 ;
      iSailStatus[8] = 4 ;
      iSailStatus[9] = 4 ;
      iSailStatus[10] = 4 ;
      iSailStatus[11] = 1 ;
      iSailStatus[12] = 0 ;
      iJibSet = 2 ;
      break ;
    case 1 :
      iSailStatus[0] = 4 ;
      iSailStatus[1] = 4 ;
      iSailStatus[2] = 3 ;
      iSailStatus[3] = 4 ;
      iSailStatus[4] = 4 ;
      iSailStatus[5] = 4 ;
      iSailStatus[6] = 4 ;
      iSailStatus[7] = 4 ;
      iSailStatus[8] = 4 ;
      iSailStatus[9] = 4 ;
      iSailStatus[10] = 4 ;
      iSailStatus[11] = 2 ;
      iSailStatus[12] = 0 ;
      iJibSet = 2 ;
      break ;
    case 0 :
      iSailStatus[0] = 4 ;
      iSailStatus[1] = 4 ;
      iSailStatus[2] = 4 ;
      iSailStatus[3] = 4 ;
      iSailStatus[4] = 4 ;
      iSailStatus[5] = 4 ;
      iSailStatus[6] = 4 ;
      iSailStatus[7] = 4 ;
      iSailStatus[8] = 4 ;
      iSailStatus[9] = 4 ;
      iSailStatus[10] = 4 ;
      iSailStatus[11] = 4 ;
      iSailStatus[12] = 4 ;
      iJibSet = 2 ;
    }

  JibSelect() ;
  if (iSailStatus[12]==4)  // jib reefed
    fSailAngle[12] = 0. ; // haul in jib upon furling
  ShowActualJibAngle () ;

  // adjust effective heights
  for (iI = 0; iI <= 12; iI++)
    {
    fEffSailHead[iI] = fSailFoot[iI] + (fSailDepth[iI] * 
      fSetFraction[iSailStatus[iI]]) ;
    fMeanSailHeight[iI] = (fEffSailHead[iI] + fSailFoot[iI]) / 2.0 ;
    }
  SailPlan () ;
  CanShadow () ;

  }

/*-----------------------------------------
   Pause
   Version date: 99.07.03
  -----------------------------------------*/
void Pause()
  {
  if (!bPaused)
    {
    bPaused = TRUE ;
    SetWindowText(hwndButton[8], "Restart") ;
    }
  else
    {
    bPaused = FALSE ;
    SetWindowText(hwndButton[8], "Pause") ;
    fLastTime = (float) clock()/CLOCKS_PER_SEC ;
    }
  SetFocus (hwndCheck[2]) ;
  }

/*-----------------------------------------
   ShowMessage
   Version date: 99.10.03
  -----------------------------------------*/
void ShowMessage ()
  {
  HDC   hdc ;
  int   iI ;
  SIZE  size ;

  hdc=GetDC (hwnd) ;
  iMessageNr++ ;
  if (iMessageNr == 6)
    {
    // scroll first message off screen
    for (iI = 0 ; iI<=4 ; iI++)
      { 
      strcpy(sShipMessage[iI],sShipMessage[iI+1]) ;
      fMessageTime[iI] = fMessageTime[iI + 1] ;
      SelectObject (hdc,GetStockObject(NULL_PEN)) ;
      Rectangle (hdc, xMessage, yMessage+ iI*iTextHeight, xMessage+140, 
        yMessage + (iI+1)*iTextHeight) ;
      SelectObject (hdc,GetStockObject(BLACK_PEN)) ;
      TextOut (hdc, xMessage, yMessage+ iI*iTextHeight, sShipMessage[iI], strlen(sShipMessage[iI])) ; 
      } 
    iMessageNr = 5 ;
    }
  GetTextExtentPoint32(hdc,sMessage,strlen(sMessage),&size) ;
  while (size.cx > 138)
    {
    sMessage[strlen(sMessage)-1]='\0';
    GetTextExtentPoint32(hdc,sMessage,strlen(sMessage),&size) ;
    }
  strcpy (sShipMessage[iMessageNr],sMessage) ;
  fMessageTime[iMessageNr] = fNow ;
  SelectObject (hdc,GetStockObject(NULL_PEN)) ;
  Rectangle (hdc, xMessage, yMessage+ iMessageNr*iTextHeight, xMessage+140, 
    yMessage + (iMessageNr+1)*iTextHeight) ;
  SelectObject (hdc,GetStockObject(BLACK_PEN)) ;
  TextOut (hdc, xMessage, yMessage+ iMessageNr*iTextHeight, sShipMessage[iMessageNr], strlen(sShipMessage[iMessageNr])) ; 
  MessageBeep(0) ;
  ReleaseDC (hwnd, hdc) ;
  }

/*-----------------------------------------
   ShowStatusMessage
   Version date: 00.06.10
  -----------------------------------------*/
void ShowStatusMessage()
  {
  HDC        hdc ;
  LPRECT     lprect ;
  RECT       rect ;

  hdc=GetDC (hwndStatus) ;
  SelectObject(hdc, MyFont) ;
  GetClientRect (hwndStatus, &rect) ;
  lprect= &rect ;
  DrawStatusText(hdc,lprect,sMessage, 0);
  ReleaseDC (hwndStatus,hdc) ;
  return ;
  }

/*-----------------------------------------
   ShowYardShown
   Version date: 99.04.25
  -----------------------------------------*/
void ShowYardShown()
  {
  HDC   hdc ;
  SIZE  size ;

  hdc=GetDC (hwnd) ;
  SelectObject(hdc,GetStockObject(NULL_PEN)) ;
  Rectangle (hdc, 5, 4, 100, 18) ;
  SelectObject(hdc, hSkyBrush) ;
  SetBkMode(hdc, TRANSPARENT) ;
  GetTextExtentPoint32(hdc,sYardLevel[iYardLevelShown],strlen(sYardLevel[iYardLevelShown]),
    &size) ; 
  Rectangle (hdc, 5, 4, 8 + size.cx, 18) ;
  SelectObject(hdc,GetStockObject(BLACK_PEN)) ;
  TextOut (hdc, 6, 4, sYardLevel[iYardLevelShown], strlen(sYardLevel[iYardLevelShown])) ;
  SetBkMode(hdc, OPAQUE) ;
  SelectObject(hdc, GetStockObject(LTGRAY_BRUSH)) ;
  ReleaseDC (hwnd, hdc) ;
  }

